#include <stdio.h>
#include <stdlib.h>
#ifndef WIN32
#include <unistd.h>
#else
#include <process.h>
#define getpid _getpid
#endif
#include "blocks.h"

int main(int argc,char **argv)
{   
    printf("Blocks V0.1 Server.\n");
    if (argc!=4 && argc!=6)
    {
        printf("usage: %s <cache size in Gb> <listen port> <max bytes per sec> [ <server> <port> ]\n",argv[0]);
        exit(0);
    }

    long cache_size_gb=atol(argv[1]);
    if (cache_size_gb<1)
        cache_size_gb=1;
    printf("using cache size of %ld Gbytes\n",cache_size_gb);

    printf("WARNING: no initial source of entropy for strong PRNG\n");
    init_blocks(cache_size_gb*16384);
        
    char *initial_server=NULL;
    long initial_server_port=-1;
    if (argc==5)
    {   
        initial_server=argv[4];
        initial_server_port=atol(argv[5]);
    }

    char tmp[256];
    sprintf(tmp,"test server PID=%ld",getpid());
    
    long rc=init_blocks_server(atol(argv[2]),
                               initial_server,initial_server_port,
                               tmp,NULL,NULL,NULL,NULL,NULL);
    if (rc<0)
    {
		printf("ERROR: cant initialise server RC=%ld\n",rc);
		exit(-1);
    }

    long bytespersec=atol(argv[3]);
    if (bytespersec<16384)
    {
        printf("WARNING: Using mimimum throttle limit of 16384 bytes/sec\n");
        blocks_set_throttle(bytespersec);
    }

	printf("online...\n");    
    // main loop... 
    while (1)
        blocks_do_io();

	return 0;
}

